################# GT applications makefile #############
#################      OS - Windows        #############

# MAKEFILE VERSION 1.0

APPS = gttp gtmem gtnex gtmon gtprog gtint gtlat gtbert
TESTAPPS = gtspeed gtrand gtniv

CC           = cl.exe
LD           = link.exe
CP           = copy
CC_INCLUDE=/I"." /I"../../inc" /I"../../gtcore"

C_PROJ_DEF= /nologo /W3 /EHa  $(CC_INCLUDE) $(D1) \
  /D "_MBCS" /D "PLATFORM_WIN" /D "_CONSOLE" /D "_CRT_SECURE_NO_DEPRECATE"

!IF "$(CFG)" == ""
CFG=scgtapps - Win32 Release
!MESSAGE CFG not set. Defaulting to $(CFG) configuration
!MESSAGE
!MESSAGE You can specify a configuration when running NMAKE
!MESSAGE by defining the macro CFG on the command line. For example:
!MESSAGE
!MESSAGE NMAKE /f "egt.win2k.mak" CFG="scgtapi - Win32 Debug"
!MESSAGE
!MESSAGE Possible choices for configuration are:
!MESSAGE
!MESSAGE "scgtapps - Win32 Release" ("Win32 (x86) Release Build")
!MESSAGE "scgtapps - Win32 Debug"   ("Win32 (x86) Debug Build")
!MESSAGE "scgtapps - Win64 Release" ("Win64 (x86) Release build")
!MESSAGE "scgtapps - Win64 Debug"   ("Win64 (x86) Debug build ")
!MESSAGE
!ENDIF

!IF "$(CFG)" == "scgtapps - Win32 Release" 
TARGET_DIR = ..\..\windows\bin
INTDIR     = .\Win32Release	
CC_DEFINES= $(C_PROJ_DEF) /D "NDEBUG" /O2 /D "WIN32" /c 
M1=/machine:X86
SCGTAPI=../../windows/lib/scgtapi.lib
!ELSEIF "$(CFG)" == "scgtapps - Win32 Debug" 
TARGET_DIR = ..\..\windows\bin
INTDIR     = .\Win32Debug
CC_DEFINES= $(C_PROJ_DEF) /D "_DEBUG" /RTCsuc  /Od /D "WIN32" /c 
M1=/machine:X86
SCGTAPI=../../windows/lib/scgtapi.lib
!ELSEIF "$(CFG)" == "scgtapps - Win64 Release" 
TARGET_DIR = ..\..\windows\bin64
INTDIR     = .\Win64Release
CC_DEFINES= $(C_PROJ_DEF) /D "NDEBUG" /O2 /D "WIN64" /c 
M1=/machine:x64
SCGTAPI=../../windows/lib64/scgtapi.lib
!ELSEIF "$(CFG)" == "scgtapps - Win64 Debug" 
TARGET_DIR = ..\..\windows\bin64
INTDIR     = .\Win64Debug
CC_DEFINES= $(C_PROJ_DEF) /D "_DEBUG" /RTCsuc  /Od /D "WIN64" /c 
M1=/machine:x64
SCGTAPI=../../windows/lib64/scgtapi.lib
!ELSE
!MESSAGE Invalid configuration "$(CFG)" specified.
!MESSAGE You can specify a configuration when running NMAKE
!MESSAGE by defining the macro CFG on the command line. For example:
!MESSAGE 
!MESSAGE NMAKE /f "scgtapi.mak" CFG="scgtapi - Win32 Debug"
!MESSAGE 
!MESSAGE Possible choices for configuration are:
!MESSAGE 
!MESSAGE "scgtapps - Win32 Release" ("Win32 (x86) Release Build")
!MESSAGE "scgtapps - Win32 Debug"   ("Win32 (x86) Debug Build")
!MESSAGE "scgtapps - Win64 Release" ("Win64 (x86) Release build")
!MESSAGE "scgtapps - Win64 Debug"   ("Win64 (x86) Debug build ")
!MESSAGE 
!ERROR invalid configuration option
!ENDIF
	
LIBS=kernel32.lib user32.lib gdi32.lib winspool.lib \
     comdlg32.lib advapi32.lib shell32.lib ole32.lib \
     oleaut32.lib uuid.lib odbc32.lib odbccp32.lib \
     kernel32.lib user32.lib gdi32.lib winspool.lib \
     comdlg32.lib advapi32.lib shell32.lib ole32.lib \
     oleaut32.lib uuid.lib odbc32.lib odbccp32.lib \
     /nologo /subsystem:console /incremental:no 


GTLIBS= $(LIBS) $(SCGTAPI)

COMMON_OBJS="$(INTDIR)\usys.obj"

#ALL : $(APPS) CLEAN
ALL : $(APPS) 

################
test: $(TESTAPPS)

################
mkdirs :
	@if not exist "$(TARGET_DIR)" mkdir "$(TARGET_DIR)"
	@if not exist "$(INTDIR)" mkdir "$(INTDIR)"

################
scripts: 
	xcopy /r scripts\*.bat $(TARGET_DIR)\

################

$(INTDIR)\gtmon.obj: gtmon.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtmon : mkdirs $(COMMON_OBJS) $(INTDIR)\gtmon.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################

$(INTDIR)\gtprog.obj: gtprog.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtprog : mkdirs $(COMMON_OBJS) $(INTDIR)\gtprog.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtnex.obj: gtnex.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtnex : mkdirs $(COMMON_OBJS) $(INTDIR)\gtnex.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtmem.obj: gtmem.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtmem : mkdirs $(COMMON_OBJS) $(INTDIR)\gtmem.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gttp.obj: gttp.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gttp : mkdirs $(COMMON_OBJS) $(INTDIR)\gttp.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<
	
################
$(INTDIR)\gtint.obj: gtint.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtint : mkdirs $(COMMON_OBJS) $(INTDIR)\gtint.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<
################
$(INTDIR)\gtlat.obj: gtlat.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtlat : mkdirs $(COMMON_OBJS) $(INTDIR)\gtlat.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtbert.obj: gtbert.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtbert : mkdirs $(COMMON_OBJS) $(INTDIR)\gtbert.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtspeed.obj: gtspeed.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtspeed : mkdirs $(COMMON_OBJS) $(INTDIR)\gtspeed.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtrand.obj: gtrand.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtrand : mkdirs $(COMMON_OBJS) $(INTDIR)\gtrand.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
$(INTDIR)\gtniv.obj: gtniv.c
	$(CC) @<<
	$(CC_DEFINES) /Fo$@ $?
<<

gtniv : mkdirs $(COMMON_OBJS) gtniv.obj
	$(LD) @<<$@.exe
	$(GTLIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $(INTDIR)\$@.obj
<<

################
"$(INTDIR)\usys.obj" : usys.c
		$(CC) $(CC_DEFINES)  /Fo$(INTDIR)\\ $?



################
#Define the implicit rule for building .obj files from .c files
.c{$(INTDIR)}.obj::
	$(CC) @<<
	$(CC_DEFINES) $< 
<<

################
CLEAN :
	del /F $(COMMON_OBJS)
	del /F $(INTDIR)\*.obj 
	del /F temp.idb

#####################################################
# THE FOLLOWING CAN BE REMOVED WHEN DONE WITH SL240 #
#####################################################

sl240: sl_warn xgttp xgtbert xgtmem xgtprog

# Must set up SL240BASE
SL240BASE=..\..\..\..\sl240\w2k\w2kwork
SL240_DEFINES = /D "HW_SL240" /I"$(SL240BASE)\inc"
SL240_COMMON_OBJS= $(COMMON_OBJS) "$(SL240BASE)\lib\sl240api.lib"

sl_warn:
	@echo "VARIABLE \"SL240BASE\" MUST POINT TO THE ROOT"
	@echo "OF YOUR SL240 DIRECTORY TREE"

xgttp.obj: gttp.c
	$(CC) @<<
	$(CC_DEFINES) $(SL240_DEFINES) /Fo$@ $?
<<

xgttp : mkdirs $(SL240_COMMON_OBJS) xgttp.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SL240_COMMON_OBJS) $@.obj
<<

xgtbert.obj: gtbert.c
	$(CC) @<<
	$(CC_DEFINES) $(SL240_DEFINES) /Fo$@ $?
<<

xgtbert : mkdirs $(SL240_COMMON_OBJS) xgtbert.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SL240_COMMON_OBJS) $@.obj
<<

xgtmem.obj: gtmem.c
	$(CC) @<<
	$(CC_DEFINES) $(SL240_DEFINES) /Fo$@ $?
<<

xgtmem : mkdirs $(SL240_COMMON_OBJS) xgtmem.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SL240_COMMON_OBJS) $@.obj
<<

xgtprog.obj: gtprog.c
	$(CC) @<<
	$(CC_DEFINES) $(SL240_DEFINES) /Fo$@ $?
<<

xgtprog : mkdirs $(SL240_COMMON_OBJS) xgtprog.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SL240_COMMON_OBJS) $@.obj
<<

########################################################
# THE FOLLOWING CAN BE REMOVED WHEN DONE WITH SCRAMNET #
########################################################

scramnet: scram_warn sgttp sgtmem sgtnex

# Must set up SCRAMBASE
SCRAMBASE=
SCR_DEFINES = -DHW_SCFF -I$(SCRAMBASE)\inc
SCR_LIBS = $(COMMON_OBJS) $(SCRAMBASE)\lib\hwd.lib $(SCRAMBASE)\lib\plus.lib

scram_warn:
	@echo "VARIABLE \"SCRAMBASE\" MUST POINT TO THE ROOT"
	@echo "OF YOUR SCRAMNET DIRECTORY TREE"


sgttp.obj: gttp.c
	$(CC) @<<
	$(CC_DEFINES) $(SCR_DEFINES) /Fo$@ $?
<<

sgttp : mkdirs $(COMMON_OBJS) sgttp.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SCR_LIBS) $@.obj
<<

sgtmem.obj: gtmem.c
	$(CC) @<<
	$(CC_DEFINES) $(SCR_DEFINES) /Fo$@ $?
<<

sgtmem : mkdirs $(COMMON_OBJS) sgtmem.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SCR_LIBS) $@.obj
<<

sgtnex.obj: gtnex.c
	$(CC) @<<
	$(CC_DEFINES) $(SCR_DEFINES) /Fo$@ $?
<<

sgtnex : mkdirs $(COMMON_OBJS) sgtnex.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SCR_LIBS) $@.obj
<<

sgtbert.obj: gtbert.c
	$(CC) @<<
	$(CC_DEFINES) $(SCR_DEFINES) /Fo$@ $?
<<

sgtbert : mkdirs $(COMMON_OBJS) sgtbert.obj
	$(LD) @<<$@.exe 
	$(LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(SCR_LIBS) $@.obj
<<

#################################################################
# SYSTEM MEMORY ONLY VERSIONS OF APPS                           #
#################################################################

# Set up memory-only versions of apps
MEM_DEFINES = -DHW_SYSTEM_MEM
MEM_LIBS = $(LIBS)

mgttp.obj: gttp.c
	$(CC) @<<
	$(CC_DEFINES) $(MEM_DEFINES) /Fo$@ $?
<<

mgttp : mkdirs $(COMMON_OBJS) mgttp.obj
	$(LD) @<<$@.exe
	$(MEM_LIBS) $(M1) /out:"$(TARGET_DIR)\$@.exe" $(COMMON_OBJS) $@.obj
<<
